/******************************************************************************
 * Copyright (C) 2018  Tadeus Prastowo <eus@member.fsf.org>                   *
 *                                            (GPG public key ID: 0x277B48A6) *
 *                                                                            *
 * This program is free software: you can redistribute it and/or modify       *
 * it under the terms of the GNU General Public License as published by       *
 * the Free Software Foundation, either version 3 of the License, or          *
 * (at your option) any later version.                                        *
 *                                                                            *
 * This program is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 * GNU General Public License for more details.                               *
 *                                                                            *
 * You should have received a copy of the GNU General Public License          *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.      *
 ******************************************************************************/

#include <type_traits>
#include "../../v1.hpp"
#include "../v1_test_utility.hpp"

namespace {
  constexpr int initval_constexpr = 16;
}

int main() {
  static constexpr int initval_static_constexpr = 8;
  static const int initval_static_const = 7;
  constexpr int initval_local_constexpr = 4;
  const int initval_local_const = 1;
  using namespace tice::v1;
  tests::utility::run<Chan_inline_init<std::remove_cv_t<decltype(initval_constexpr)>, initval_constexpr>>();
  tests::utility::run<Chan_inline_init<decltype(initval_constexpr > 8), (initval_constexpr > 8)>>();
  tests::utility::run<Chan_inline_init<std::remove_cv_t<decltype(initval_constexpr)>, initval_constexpr - 8>>();
  tests::utility::run<Chan_inline_init<std::remove_cv_t<decltype(initval_constexpr)>, 90 / 11>>();
  tests::utility::run<Chan_inline_init<std::remove_cv_t<decltype(initval_constexpr)>, 11>>();
  tests::utility::run<Chan_inline_init<long long, initval_constexpr>>();
  tests::utility::run<Chan_inline_init<bool, (initval_constexpr > 8)>>();
  tests::utility::run<Chan_inline_init<long long, initval_constexpr - 8>>();
  tests::utility::run<Chan_inline_init<long long, 90 / 11>>();
  tests::utility::run<Chan_inline_init<long long, 11>>();
  tests::utility::run<Chan_inline_init<long long, initval_static_constexpr>>();
  tests::utility::run<Chan_inline_init<long long, initval_static_const>>();
  tests::utility::run<Chan_inline_init<long long, initval_local_constexpr>>();
  tests::utility::run<Chan_inline_init<long long, initval_local_const>>();
}
