/******************************************************************************
 * Copyright (C) 2018  Tadeus Prastowo <eus@member.fsf.org>                   *
 *                                            (GPG public key ID: 0x277B48A6) *
 *                                                                            *
 * This program is free software: you can redistribute it and/or modify       *
 * it under the terms of the GNU General Public License as published by       *
 * the Free Software Foundation, either version 3 of the License, or          *
 * (at your option) any later version.                                        *
 *                                                                            *
 * This program is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of             *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              *
 * GNU General Public License for more details.                               *
 *                                                                            *
 * You should have received a copy of the GNU General Public License          *
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.      *
 ******************************************************************************/

#include "../../v1.hpp"
#include "../v1_test_utility.hpp"

double fn1() {
  return .24;
}

double fn2(double arg1) {
  return arg1;
}

double fn3(double arg1, int arg2) {
  return arg1 / arg2;
}

void fn4() {
}

void fn5(double arg1) {
}

void fn6(double arg1, int arg2) {
}

int main() {
  using namespace tice::v1;
  typedef Comp(&fn1, Ratio<1>) comp1;
  typedef Comp(&fn2, Ratio<1, 3>) comp2;
  typedef Comp(&fn3, Ratio<1, 12>) comp3;
  typedef Comp(&fn4, Ratio<7, 8>) comp4;
  typedef Comp(&fn5, Ratio<4, 3>) comp5;
  typedef Comp(&fn6, Ratio<9, 8>) comp6;
  tests::utility::run<Node<comp1, Ratio<4, 3>>>();
  tests::utility::run<Node<comp2, Ratio<4, 3>>>();
  tests::utility::run<Node<comp3, Ratio<4, 3>>>();
  tests::utility::run<Node<comp4, Ratio<4, 3>>>();
  tests::utility::run<Node<comp5, Ratio<4, 3>>>();
  tests::utility::run<Node<comp6, Ratio<4, 3>>>();
}
